// (C) SSoft z-print@bk.ru
//  скрипт для Adobe Acrobat 
//  размещает страницы из файла А5 по 3 на странице А4 на в новый файл, по заданным координатам
//  в Add-on Tools появится скрипт Place 3 pages


const A4H = 297
const A4W = 210
const A5H = 210
const A5W = 148
//  х-координаты для размещения страниц, первая в паре - левая, вторая - правая
const posX = [[0, A5W], [40, 40 + A5W], [150, 150 + A5W]];

const PGPUT = 3; //  количество страниц для размещения


const cmName = "Place 3 pages";
const cmProc = "place3pages()"
if (app.viewerVersion < 10) {
    app.addMenuItem({ cName: cmName, cUser: cmName, cParent: "Tools", cExec: cmProc, cEnable: "event.rc = (event.target != null);"});
} else {
    app.addToolButton({ cName: cmName, cLabel: cmName, cExec: cmProc, cEnable: "event.rc = (event.target != null);"});   
};    

//  конвертирует из миллиметров в пункты
function mm2pt_(mm) {
    return mm * 2.834;
};

place3pages = app.trustedFunction(function() {
	app.beginPriv();
	outDoc = app.newDoc(mm2pt_(A4H), mm2pt_(A4W));
	var aRect = [];
	
	for (var i = 0; (i + PGPUT) <= this.numPages; i += PGPUT) {
		for (var j = 0; j < PGPUT; j++) {
			console.println("pg_" + (i + j));
			aRect =  [mm2pt_(posX[j][0]), mm2pt_(A4W), mm2pt_(posX[j][1]), mm2pt_(0)]; 
			var f = outDoc.addField("pg_" + (i + j), "button", outDoc.numPages - 1, aRect);
			f.buttonImportIcon(this.path, i + j);
			f.buttonFitBounds = false;
			f.buttonScaleWhen = scaleWhen.never;
			f.buttonPosition = position.iconOnly;
			f.lineWidth = 0;
		};
		outDoc.newPage(outDoc.numPages, mm2pt_(A4H), mm2pt_(A4W));
	}
	outDoc.flattenPages();
	outDoc.deletePages(outDoc.numPages - 1);
	app.endPriv();
})
